; ktable.asm from rs_kbd project: AT keyboard scancode tables
; 
; Copyright 2016,2017 Mihai Gaitos, mihaig@hawk.ro
; 
; Permission is hereby granted, without written agreement and without
; license or royalty fees, to use, copy, modify, and distribute this
; software and its documentation for any purpose, provided that the
; above copyright notice and the following two paragraphs appear in
; all copies of this software.
; 
; IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE TO ANY PARTY FOR
; DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
; ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
; IF THE COPYRIGHT HOLDER HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
; DAMAGE.
; 
; THE COPYRIGHT HOLDER SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING,
; BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
; FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
; ON AN "AS IS" BASIS, AND THE COPYRIGHT HOLDER HAS NO OBLIGATION TO
; PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

	ORG H'100'
SCTABLE
		ADDWF	PCL,1
;0
		RETLW	H'00'
		RETLW	H'E8'	; F9
		RETLW	H'E6'	; *** modified F7
		RETLW	H'E4'	; F5
;4
		RETLW	H'E2'	; F3
		RETLW	H'E0'	; F1
		RETLW	H'E1'	; F2
		RETLW	H'00'
;8
		RETLW	H'00'
		RETLW	H'E9'	; F10
		RETLW	H'E7'	; F8
		RETLW	H'E5'	; F6
;C
		RETLW	H'E3'	; F4
		RETLW	H'09'	; TAB
		RETLW	'`'
		RETLW	H'00'
;----
;10
		RETLW	H'00'
		RETLW	H'00'	; Alt (E0+ = right Alt)
		RETLW	H'00'	; Shift
		RETLW	H'CA'	; (unused) wheel up - not implemented
;14
		RETLW	H'00'
		RETLW	'q'
		RETLW	'1'
		RETLW	H'EA'	; (unused) wheel left
;18
		RETLW	H'EB'	; (unused) wheel right
		RETLW	H'CB'	; (unused) wheel down - not implemented
		RETLW	'z'
		RETLW	's'
;1C
		RETLW	'a'
		RETLW	'w'
		RETLW	'2'
		RETLW	H'00'	; left Windows (E0+)
;----
;20
		RETLW	H'00'
		RETLW	'c'
		RETLW	'x'
		RETLW	'd'
;24
		RETLW	'e'
		RETLW	'4'
		RETLW	'3'
		RETLW	H'00'	; right Windows (E0+)
;28
		RETLW	H'00'
		RETLW	' '
		RETLW	'v'
		RETLW	'f'
;2C
		RETLW	't'
		RETLW	'r'
		RETLW	'5'
		RETLW	H'00'	; right(?) Menu (E0+)
;----
;30
		RETLW	H'00'
		RETLW	'n'
		RETLW	'b'
		RETLW	'h'
;34
		RETLW	'g'
		RETLW	'y'
		RETLW	'6'
		RETLW	H'00'	; Wake Up
;38
		RETLW	H'00'
		RETLW	H'00'
		RETLW	'm'
		RETLW	'j'
;3C
		RETLW	'u'
		RETLW	'7'
		RETLW	'8'
		RETLW	H'00'	; Sleep
;----
;40
		RETLW	H'00'
		RETLW	','
		RETLW	'k'
		RETLW	'i'
;44
		RETLW	'o'
		RETLW	'0'
		RETLW	'9'
		RETLW	H'00'
;48
		RETLW	H'00'
		RETLW	'.'
		RETLW	'/'
		RETLW	'l'
;4C
		RETLW	';'
		RETLW	'p'
		RETLW	'-'
		RETLW	H'00'
;----
;50
		RETLW	H'00'
		RETLW	H'00'
		RETLW	'\''
		RETLW	H'00'
;54
		RETLW	'['
		RETLW	'='
		RETLW	H'00'
		RETLW	H'00'
;58
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'0D'	; CR
		RETLW	']'
;5C
		RETLW	H'00'
		RETLW	'\\'
		RETLW	H'00'	; Power
		RETLW	H'00'
;----
;60
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'00'
;64
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'7F'	; BACKSPACE (DEL on R&S)
		RETLW	H'00'
;68						; special numeric keys (and ESC)
		RETLW	H'00'
		RETLW	H'B1'	; n1
		RETLW	H'00'
		RETLW	H'B4'	; n2
;6C
		RETLW	H'B7'	; n7
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'00'
;----
;70
		RETLW	H'B0'	; n0
		RETLW	H'AE'	; n.
		RETLW	H'B2'	; n2
		RETLW	H'B5'	; n5
;74
		RETLW	H'B6'	; n6
		RETLW	H'B8'	; n8
		RETLW	H'1B'	; ESCAPE
		RETLW	H'00'
;78
		RETLW	H'00'
		RETLW	'+'		; n+
		RETLW	H'B3'	; n3
		RETLW	'-'		; n-
;7C
		RETLW	'*'		; n*
		RETLW	H'B9'
		RETLW	H'FF'	; Break (Ctrl+Pause, different scancode!)
; no 7F!
;----

; !!! +80h (shift)
	ORG H'181'

;0
		RETLW	H'00'
		RETLW	H'C8'	; F9
		RETLW	H'C6'	; *** modified F7
		RETLW	H'C4'	; F5
;4
		RETLW	H'C2'	; F3
		RETLW	H'C0'	; F1
		RETLW	H'C1'	; F2
		RETLW	H'00'
;8
		RETLW	H'00'
		RETLW	H'C9'	; F10
		RETLW	H'C7'	; F8
		RETLW	H'C5'	; F6
;C
		RETLW	H'C3'	; F4
		RETLW	H'09'	; TAB
		RETLW	'~'
		RETLW	H'00'
;----
;10
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'EA'
;14
		RETLW	H'00'
		RETLW	'Q'
		RETLW	'!'
		RETLW	H'CA'
;18
		RETLW	H'CB'
		RETLW	H'EB'
		RETLW	'Z'
		RETLW	'S'
;1C
		RETLW	'A'
		RETLW	'W'
		RETLW	'@'
		RETLW	H'00'
;----
;20
		RETLW	H'00'
		RETLW	'C'
		RETLW	'X'
		RETLW	'D'
;24
		RETLW	'E'
		RETLW	'$'
		RETLW	'#'
		RETLW	H'00'
;28
		RETLW	H'00'
		RETLW	' '
		RETLW	'V'
		RETLW	'F'
;2C
		RETLW	'T'
		RETLW	'R'
		RETLW	'%'
		RETLW	H'00'
;----
;30
		RETLW	H'00'
		RETLW	'N'
		RETLW	'B'
		RETLW	'H'
;34
		RETLW	'G'
		RETLW	'Y'
		RETLW	'^'
		RETLW	H'00'
;38
		RETLW	H'00'
		RETLW	H'00'
		RETLW	'M'
		RETLW	'J'
;3C
		RETLW	'U'
		RETLW	'&'
		RETLW	'*'
		RETLW	H'00'
;----
;40
		RETLW	H'00'
		RETLW	'<'
		RETLW	'K'
		RETLW	'I'
;44
		RETLW	'O'
		RETLW	')'
		RETLW	'('
		RETLW	H'00'
;48
		RETLW	H'00'
		RETLW	'>'
		RETLW	'?'
		RETLW	'L'
;4C
		RETLW	':'
		RETLW	'P'
		RETLW	'_'
		RETLW	H'00'
;----
;50
		RETLW	H'00'
		RETLW	H'00'
		RETLW	'\"'
		RETLW	H'00'
;54
		RETLW	'{'
		RETLW	'+'
		RETLW	H'00'
		RETLW	H'00'
;58
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'0D'	; CR
		RETLW	'}'
;5C
		RETLW	H'00'
		RETLW	'|'
		RETLW	H'00'
		RETLW	H'00'
;----
;60
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'00'
;64
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'08'	; BACKSPACE
		RETLW	H'00'
;68						; special numeric keys (and ESC)
		RETLW	H'00'
		RETLW	H'B1'	; n1
		RETLW	H'00'
		RETLW	H'B4'	; n2
;6C
		RETLW	H'B7'	; n7
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'00'
;----
;70
		RETLW	H'B0'	; n0
		RETLW	H'AE'	; n.
		RETLW	H'B2'	; n2
		RETLW	H'B5'	; n5
;74
		RETLW	H'B6'	; n6
		RETLW	H'B8'	; n8
		RETLW	H'1B'	; ESCAPE
		RETLW	H'00'
;78
		RETLW	H'00'
		RETLW	'+'		; n+
		RETLW	H'B3'	; n3
		RETLW	'-'		; n-
;7C
		RETLW	'*'		; n*
		RETLW	H'B9'
		RETLW	H'FF'	; Break (Ctrl+Pause, different scancode!)
; no 7F (luckily there is no such scancode)


; *** CTRL ***
	ORG H'200'
SCTAB_CTRL
		ADDWF	PCL,1
;0
		RETLW	H'00'
		RETLW	H'88'	; F9
		RETLW	H'86'	; *** modified F7
		RETLW	H'84'	; F5
;4
		RETLW	H'82'	; F3
		RETLW	H'80'	; F1
		RETLW	H'81'	; F2
		RETLW	H'00'
;8
		RETLW	H'00'
		RETLW	H'89'	; F10
		RETLW	H'87'	; F8
		RETLW	H'85'	; F6
;C
		RETLW	H'83'	; F4
		RETLW	H'09'	; TAB
		RETLW	H'00'	; `
		RETLW	H'00'
;----
;10
		RETLW	H'00'
		RETLW	H'00'	; Alt (E0+ = right Alt)
		RETLW	H'00'
		RETLW	H'00'
;14
		RETLW	H'00'
		RETLW	'Q'-H'40'
		RETLW	H'00'	; 1
		RETLW	H'8A'
;18
		RETLW	H'8B'
		RETLW	H'00'
		RETLW	'Z'-H'40'
		RETLW	'S'-H'40'
;1C
		RETLW	'A'-H'40'
		RETLW	'W'-H'40'
		RETLW	H'00'	; 2
		RETLW	H'00'	; left Windows (E0+)
;----
;20
		RETLW	H'00'
		RETLW	'C'-H'40'
		RETLW	'X'-H'40'
		RETLW	'D'-H'40'
;24
		RETLW	'E'-H'40'
		RETLW	H'00'	; 4
		RETLW	H'00'	; 3
		RETLW	H'00'	; right Windows (E0+)
;28
		RETLW	H'00'
		RETLW	' '
		RETLW	'V'-H'40'
		RETLW	'F'-H'40'
;2C
		RETLW	'T'-H'40'
		RETLW	'R'-H'40'
		RETLW	H'00'	; 5
		RETLW	H'00'	; right(?) Menu (E0+)
;----
;30
		RETLW	H'00'
		RETLW	'N'-H'40'
		RETLW	'B'-H'40'
		RETLW	'H'-H'40'
;34
		RETLW	'G'-H'40'
		RETLW	'Y'-H'40'
		RETLW	H'1E'	; 6
		RETLW	H'00'	; Wake Up
;38
		RETLW	H'00'
		RETLW	H'00'
		RETLW	'M'-H'40'
		RETLW	'J'-H'40'
;3C
		RETLW	'U'-H'40'
		RETLW	H'00'	; 7
		RETLW	H'00'	; 8
		RETLW	H'00'	; Sleep
;----
;40
		RETLW	H'00'
		RETLW	','
		RETLW	'K'-H'40'
		RETLW	'I'-H'40'
;44
		RETLW	'O'-H'40'
		RETLW	H'00'	; 0
		RETLW	H'00'	; 9
		RETLW	H'00'
;48
		RETLW	H'00'
		RETLW	'.'
		RETLW	'/'
		RETLW	'L'-H'40'
;4C
		RETLW	';'
		RETLW	'P'-H'40'
		RETLW	H'AD'
		RETLW	H'00'
;----
;50
		RETLW	H'00'
		RETLW	H'00'
		RETLW	'\''
		RETLW	H'00'
;54
		RETLW	'['-H'40'
		RETLW	'='
		RETLW	H'00'
		RETLW	H'00'
;58
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'0A'	; CR
		RETLW	']'-H'40'
;5C
		RETLW	H'00'
		RETLW	'\\'-H'40'
		RETLW	H'00'	; Power
		RETLW	H'00'
;----
;60
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'00'
;64
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'1F'	; BACKSPACE (DEL on R&S)
		RETLW	H'00'
;68						; special numeric keys (and ESC)
		RETLW	H'00'
		RETLW	H'F1'	; n1
		RETLW	H'00'
		RETLW	H'F4'	; n2
;6C
		RETLW	H'F7'	; n7
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'00'
;----
;70
		RETLW	H'F0'	; n0
		RETLW	H'FB'	; n.
		RETLW	H'F2'	; n2
		RETLW	H'F5'	; n5
;74
		RETLW	H'F6'	; n6
		RETLW	H'F8'	; n8
		RETLW	H'1B'	; ESCAPE
		RETLW	H'00'
;78
		RETLW	H'00'
		RETLW	'+'		; n+
		RETLW	H'F3'	; n3
		RETLW	H'FA'; n-
;7C
		RETLW	'*'		; n*
		RETLW	H'F9'
		RETLW	H'FF'	; Break (Ctrl+Pause, different scancode than Pause)
; no 7F!
;----

	ORG		H'280'
SCTABN
		ADDWF	PCL,1

;68						; special numeric keys (and ESC)
		RETLW	H'00'
		RETLW	H'31'	; n1
		RETLW	H'00'
		RETLW	H'34'	; n2
;6C
		RETLW	H'37'	; n7
		RETLW	H'00'
		RETLW	H'00'
		RETLW	H'00'
;----
;70
		RETLW	H'30'	; n0
		RETLW	'.'		; n.
		RETLW	H'32'	; n2
		RETLW	H'35'	; n5
;74
		RETLW	H'36'	; n6
		RETLW	H'38'	; n8
		RETLW	H'1B'	; ESCAPE
		RETLW	H'00'
;78
		RETLW	H'00'
		RETLW	'+'		; n+
		RETLW	H'33'	; n3
		RETLW	'-'		; n-
;7C
		RETLW	'*'		; n*
		RETLW	H'39'	; n9
		RETLW	H'00'
